#ifndef _XHANABI_TamaP_h_INCLUDED_
#define _XHANABI_TamaP_h_INCLUDED_

#include "Tama.h"
#include "etc.h"

typedef struct _TamaClass {
  char * name;
  int size;    /* ̤礭(Ⱦ) */
  double probability; /* иΨ */
  double air;  /*  */
  double gravity; /* ϲ® */
  double transmission; /* ȯˡζ̤®٤뤫 */
  int after_image_length; /* Ĺ */
  int fine; /* ưκ٤(տϡ̤ΰưΥƥå׿ˤʤ) */

  ObjList gc_list_list; /* AfterImages οѲѤGCΥꥹȤΥꥹ */
  ObjList next_list;
} _TamaClass;

typedef struct _TamaNext {
  struct _TamaClass * tama_class;
  double power; /* ȯζ */
  int number;   /* ȯΤȤ˽Ф̤ο */
} _TamaNext;

typedef struct _Tamas {
  struct _TamaClass * tama_class;
  int number;
  int * change_flags;
  double * old_x;
  double * old_y;
  double * old_z;
  double * new_x;
  double * new_y;
  double * new_z;
  double * x1; /*  */
  double * y1; /*  */
  double * z1; /* (Ԥ) */
  double * x2; /*  */
  double * y2; /*  */
  double * z2; /* (Ԥ) */
  double * vx; /* ® */
  double * vy; /* ® */
  double * vz; /* ®(Ԥ) */
  ObjListData gc_list; /* GCꥹȤѲ */
} _Tamas;

#endif /* _XHANABI_TamaP_h_INCLUDED_ */

